import { useState, useEffect } from "react";
import { Navigate } from "react-router-dom";
import { IOCUndeployDialog } from "../IOCUndeployDialog";
import { useStartJobMutation } from "../../../store/enhancedApi";

export const UndeployIOC = ({ open, setOpen, submitCallback, ioc }) => {
  const [error, setError] = useState();

  const [
    undeploy,
    { data: undeployment, error: unDeploymentError, isLoading }
  ] = useStartJobMutation();

  useEffect(() => {
    if (unDeploymentError) {
      setError(unDeploymentError);
    }
  }, [unDeploymentError]);

  if (!undeployment) {
    return (
      <IOCUndeployDialog
        open={open}
        setOpen={setOpen}
        submitCallback={undeploy}
        ioc={ioc}
        error={error}
        resetError={() => setError(null)}
        buttonDisabled={ioc.operationInProgress || isLoading}
      />
    );
  } else {
    submitCallback(); // This works but throws a warning because I am changing state in the parent while the child is rerendering. Not sure yet how to fix.
    return (
      <Navigate
        to={`/jobs/${undeployment.id}`}
        push
      />
    );
  }
};
